import getExecutablePathsFromEnv from "../Tools/GetExecutablePathsFromEnv";
import tryGetCompilerVersion from "../Tools/TryGetCompilerVersion";
import Compiler from "./Compiler";

export default class GppCompiler implements Compiler{
    compilerPath: string;
    compilerVersion: string;
    compilerName: string = "g++";
    // staticCompilerName: string = "g++";
    constructor()
    constructor(path:string)
    constructor(path?:string,version?:string){
        if(path){
            this.compilerPath = `"${path}"`
        }else{
            const compilerPaths = getExecutablePathsFromEnv(this.compilerName)
            if(compilerPaths.length==0)throw Error(`cannot find ${this.compilerName} compiler`)
            this.compilerPath =  `"${compilerPaths[0]}"`
        }
        if(version){
            this.compilerVersion = version
        }else{
            this.compilerVersion = tryGetCompilerVersion(this.compilerPath,"--version")
        }
    }
}